//
//  ARCSingleton.m
//  testSingleton
//
//  Created by shawn li on 13-7-24.
//  Copyright (c) 2013年 bigbellshawn. All rights reserved.
//

#import "ARCSingleton.h"

//@interface ARCSingleton()
//@property (nonatomic, strong) NSArray *arr;
//@end

@implementation ARCSingleton
@synthesize arr = _arr;
+ (ARCSingleton *) sharedInstance
{
    static  ARCSingleton *sharedInstance = nil ;
    static  dispatch_once_t onceToken;  // 锁
    dispatch_once (&onceToken, ^ {     // 最多调用一次
        sharedInstance = [[self  alloc] init];
    });
    return  sharedInstance;
}

// 当第一次使用这个单例时，会调用这个init方法。
- (id)init
{
    self = [super init];
    
    if (self) {
        // 通常在这里做一些相关的初始化任务
        
    }
    
    return self;
}

- (NSMutableArray *)arr
{
    if (!_arr) {
        _arr = [[NSMutableArray alloc] initWithObjects:@"I m the first one",@"I m the second one",@"I m the third one",@"I m the last one", nil];
    }
    
    return _arr;
}


@end
