//
//  Singleton.m
//  testSingleton
//
//  Created by shawn li on 13-7-24.
//  Copyright (c) 2013年 bigbellshawn. All rights reserved.
//

#import "Singleton.h"


static int number = 1;//1 表示实例未创建， 0表示实例已创建
@interface Singleton()
@property (nonatomic, strong) NSArray *arr;

@end

@implementation Singleton
@synthesize arr = _arr;

//test static
+ (int)singleton1
{
    return number;
}

// getter
- (NSArray *)arr
{
    if (!_arr) {
        _arr = [[NSArray alloc] initWithObjects:@"1",@"2",@"3",@"4",@"5",@"6", nil];
    }
    return _arr;
}

- (id)init
{
    self = [super init];
    if (!self) {
        
    }
    return self;
}

+ (Singleton *)singleton2
{
    if (number == 1) {
        static Singleton *singleton = nil;
        singleton = [[self alloc] init];
        number = 0;
    }
    
    return singleton;
}


@end
